#ifndef MODULWINDOW_HPP
#define MODULWINDOW_HPP

#include "MainWindowController.hpp"
#include <QStandardItemModel>
#include <QString>
#include <QDateEdit> 
#include <QFileDialog>
#include <QStringListModel>
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Context.hpp"
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Modul.hpp"
#include "../../../YAOObjects/Trajectory.hpp"
//#include "../../../YAOObjects/Operator.hpp"
#include "../../ui_modulwindow.h"


class ModulWindow: public QWidget, public Ui::ModulWindow/*, public yao::Modul*/ {

	Q_OBJECT

	public :
		ModulWindow(yao::Table <yao::Modul> *aModulTable, yao::Table <yao::Space> *aSpaceIdentifier, yao::Table <yao::Operator> *anOperatorTable, yao::Table <yao::Constant> *aConstantTable, MainWindowController *mwc, std::string *aProjectName, std::string *aProjectPath, QWidget *parent=0);

		bool isModulTableEmpty(); 
		void toInitialize();

	private slots:

            	void saveModulData();
		void addModulRow();
		void addLoperaRow();
		void deleteLoperaRow();
		void deleteModulRow();
	        void callModulHelp();		

	signals:
		void modulWindowIsClosed(int anInt); 
	
	protected:
		void closeEvent(QCloseEvent *event);
		void generateModulFile(string aFilename); 

	private:

		QStandardItemModel *m_modulModel;
		QStandardItemModel *m_loperaModel;
                QModelIndex index;
                QModelIndex m_loperaIndex;
   
		std::string m_localModulName;
		std::string m_localModulParent;
		
		bool state;

		std::string *m_localProjectPath;
		std::string *m_localProjectName;
		yao::Table <yao::Modul> *m_localModulTable;
		std::vector<std::string> anVector;
		yao::Table <yao::Constant> *localConstantTable;
		yao::Table <yao::Space> *m_localSpaceTable;
		yao::Table <yao::Operator> *m_localOperaTable;
		MainWindowController *localMwc;
		QDateEdit *date;

};

#endif 
